/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package edu.harvard.iq.dataverse;

import edu.harvard.iq.dataverse.pidproviders.PidUtil;
import java.io.IOException;
import jakarta.ejb.EJB;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

/**
 *
 * @author gdurand
 */
public class CitationServlet extends HttpServlet {

    @EJB
    DvObjectServiceBean dvObjectService;
    
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        
        String persistentId = request.getParameter("persistentId");
        if (persistentId != null) {
            GlobalId pid = PidUtil.parseAsGlobalID(persistentId);
            DvObject dob = dvObjectService.findByGlobalId(pid);
            if (dob == null) {
                dob = dvObjectService.findByAltGlobalId(pid, DvObject.DType.Dataset);
                if (dob == null) {
                    dob = dvObjectService.findByAltGlobalId(pid, DvObject.DType.DataFile);
                }
            }
            if (dob != null) {
                if (dob instanceof Dataset) {
                    response.sendRedirect("dataset.xhtml?persistentId=" + persistentId);
                } else if (dob instanceof DataFile) {
                    response.sendRedirect("file.xhtml?persistentId=" + persistentId);
                }
                return;
            }
        }
        response.sendError(HttpServletResponse.SC_NOT_FOUND);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Servlet for redirecting requests from persistent identifier references.";
    }// </editor-fold>

}
